﻿/*
	OpenCLSGEMM.h -- equates for OpenCLSGEMM XOP
*/

#include <CL/cl.hpp>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <CLUtil.hpp>
//#include <MatrixMultiplication.hpp>

#include <iostream>
#include <string>
#include <vector>
using namespace std;
using namespace appsdk;

// OpenCL computation related definitions
#define WPT 4
//#define TSM 512                // The tile-size in dimension M
//#define TSN 512                // The tile-size in dimension N
//#define TSK 32                 // The tile-size in dimension K
//#define WPTM 8                 // The work-per-thread in dimension M
//#define WPTN 8                 // The work-per-thread in dimension N
//#define RTSM (TSM/WPTM)        // The reduced tile-size in dimension M
//#define RTSN (TSN/WPTN)        // The reduced tile-size in dimension N
//#define LPTA ((TSK*TSM)/(RTSM*RTSN)) // Loads-per-thread for A
//#define LPTB ((TSK*TSN)/(RTSM*RTSN)) // Loads-per-thread for B

/* OpenCLSGEMM custom error codes */

#define OLD_IGOR				1 + FIRST_XOP_ERR
#define NON_EXISTENT_WAVE		2 + FIRST_XOP_ERR
#define NEEDS_3D_WAVE			3 + FIRST_XOP_ERR
#define WAVE_DIM_MISMATCH		4 + FIRST_XOP_ERR
#define WAVE_DType_MISMATCH		5 + FIRST_XOP_ERR
#define NO_PLATFORM				6 + FIRST_XOP_ERR
#define NO_GPU					7 + FIRST_XOP_ERR
#define CREATE_CONTEXT_FAIL		8 + FIRST_XOP_ERR
#define CREATE_QUEUE_FAIL		9 + FIRST_XOP_ERR
#define LOAD_KERNEL_FAIL		10 + FIRST_XOP_ERR
#define CREATE_PROGRAM_FAIL		11 + FIRST_XOP_ERR
#define CREATE_EXE_FAIL			12 + FIRST_XOP_ERR
#define CREATE_COM_KERNEL_FAIL	13 + FIRST_XOP_ERR
#define DEVICE_MEM_ALLOC_FAIL	14 + FIRST_XOP_ERR
#define COMPUTE_FAIL			15 + FIRST_XOP_ERR
#define MEM_CP_DTH_FAIL			16 + FIRST_XOP_ERR
#define GPU_MEM_EXCEEDED		17 + FIRST_XOP_ERR

/* Prototypes */
HOST_IMPORT int XOPMain(IORecHandle ioRecHandle);