/* OpenCLSGEMM.cl
 * Matrix multiplication: outMatrix = inMatrix1 * inMatrix2.
 * credit to 5KK73 GPU assignment website 2014/2015
 */
 
// First naive implementation
__kernel void myGEMM1(const int M, const int N, const int K,
                      const __global float* inM1,
                      const __global float* inM2,
                      __global float* outM) {
    
    // Thread identifiers
    const int globalRow = get_global_id(0); // Row ID of inM1 (0..M)
    const int globalCol = get_global_id(1); // Col ID of inM2 (0..N)
 
    // Compute a single element (loop over K)
    float acc = 0.0f;
    for (int k=0; k<K; k++) {
        acc += inM1[k*M + globalRow] * inM2[globalCol*K + k];
    }
 
    // Store the result
    outM[globalCol*M + globalRow] = acc;
}